diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/energy/helper/energy-model-helper.h ns-3.42/src/energy/helper/energy-model-helper.h
--- ns-3.41/src/energy/helper/energy-model-helper.h	2024-02-09 14:44:07.905790000 -0800
+++ ns-3.42/src/energy/helper/energy-model-helper.h	2024-05-29 15:29:46.948073100 -0700
@@ -62,7 +62,7 @@
      *
      * This function installs an EnergySource onto a node.
      */
-    EnergySourceContainer Install(Ptr<Node> node) const;
+    energy::EnergySourceContainer Install(Ptr<Node> node) const;
 
     /**
      * \param c List of nodes where EnergySource will be installed.
@@ -70,7 +70,7 @@
      *
      * This function installs an EnergySource onto a list of nodes.
      */
-    EnergySourceContainer Install(NodeContainer c) const;
+    energy::EnergySourceContainer Install(NodeContainer c) const;
 
     /**
      * \param nodeName Name of node where EnergySource will be installed.
@@ -78,14 +78,14 @@
      *
      * This function installs an EnergySource onto a node.
      */
-    EnergySourceContainer Install(std::string nodeName) const;
+    energy::EnergySourceContainer Install(std::string nodeName) const;
 
     /**
      * \brief This function installs an EnergySource on all nodes in simulation.
      *
      * \returns An EnergySourceContainer which contains all the EnergySources.
      */
-    EnergySourceContainer InstallAll() const;
+    energy::EnergySourceContainer InstallAll() const;
 
   private:
     /**
@@ -97,7 +97,7 @@
      * the installation process (eg. installing EnergySource on set of nodes) is
      * implemented in the EnergySourceHelper base class.
      */
-    virtual Ptr<EnergySource> DoInstall(Ptr<Node> node) const = 0;
+    virtual Ptr<energy::EnergySource> DoInstall(Ptr<Node> node) const = 0;
 };
 
 /**
@@ -132,7 +132,8 @@
      * Installs an DeviceEnergyModel with a specified EnergySource onto a
      * xNetDevice.
      */
-    DeviceEnergyModelContainer Install(Ptr<NetDevice> device, Ptr<EnergySource> source) const;
+    energy::DeviceEnergyModelContainer Install(Ptr<NetDevice> device,
+                                               Ptr<energy::EnergySource> source) const;
 
     /**
      * \param deviceContainer List of NetDevices to be install DeviceEnergyModel
@@ -144,8 +145,8 @@
      * Installs DeviceEnergyModels with specified EnergySources onto a list of
      * NetDevices.
      */
-    DeviceEnergyModelContainer Install(NetDeviceContainer deviceContainer,
-                                       EnergySourceContainer sourceContainer) const;
+    energy::DeviceEnergyModelContainer Install(NetDeviceContainer deviceContainer,
+                                               energy::EnergySourceContainer sourceContainer) const;
 
   private:
     /**
@@ -158,8 +159,8 @@
      * node. The rest of the installation process (eg. installing EnergySource on
      * set of nodes) is implemented in the DeviceEnergyModelHelper base class.
      */
-    virtual Ptr<DeviceEnergyModel> DoInstall(Ptr<NetDevice> device,
-                                             Ptr<EnergySource> source) const = 0;
+    virtual Ptr<energy::DeviceEnergyModel> DoInstall(Ptr<NetDevice> device,
+                                                     Ptr<energy::EnergySource> source) const = 0;
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/energy/helper/energy-source-container.cc ns-3.42/src/energy/helper/energy-source-container.cc
--- ns-3.41/src/energy/helper/energy-source-container.cc	2024-02-09 14:44:07.905790000 -0800
+++ ns-3.42/src/energy/helper/energy-source-container.cc	2024-05-29 15:29:46.948073100 -0700
@@ -25,6 +25,8 @@
 
 namespace ns3
 {
+namespace energy
+{
 
 NS_OBJECT_ENSURE_REGISTERED(EnergySourceContainer);
 
@@ -141,4 +143,5 @@
     }
 }
 
+} // namespace energy
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/energy/helper/energy-source-container.h ns-3.42/src/energy/helper/energy-source-container.h
--- ns-3.41/src/energy/helper/energy-source-container.h	2024-02-09 14:44:07.905790000 -0800
+++ ns-3.42/src/energy/helper/energy-source-container.h	2024-05-29 15:29:46.948073100 -0700
@@ -30,6 +30,8 @@
 
 namespace ns3
 {
+namespace energy
+{
 
 /**
  * \ingroup energy
@@ -181,6 +183,7 @@
     std::vector<Ptr<EnergySource>> m_sources; //!< Energy source container
 };
 
+} // namespace energy
 } // namespace ns3
 
 #endif /* ENERGY_SOURCE_CONTAINER_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/energy/helper/generic-battery-model-helper.cc ns-3.42/src/energy/helper/generic-battery-model-helper.cc
--- ns-3.41/src/energy/helper/generic-battery-model-helper.cc	2024-02-09 14:44:07.905790000 -0800
+++ ns-3.42/src/energy/helper/generic-battery-model-helper.cc	2024-05-29 15:29:46.948073100 -0700
@@ -37,20 +37,21 @@
     m_batteryModel.Set(name, v);
 }
 
-Ptr<EnergySource>
+Ptr<energy::EnergySource>
 GenericBatteryModelHelper::DoInstall(Ptr<Node> node) const
 {
     NS_ASSERT(node != nullptr);
-    Ptr<EnergySource> energySource = m_batteryModel.Create<EnergySource>();
+    Ptr<energy::EnergySource> energySource = m_batteryModel.Create<energy::EnergySource>();
     NS_ASSERT(energySource != nullptr);
     energySource->SetNode(node);
     return energySource;
 }
 
-Ptr<EnergySourceContainer>
+Ptr<energy::EnergySourceContainer>
 GenericBatteryModelHelper::Install(NodeContainer c) const
 {
-    Ptr<EnergySourceContainer> batteryContainer = CreateObject<EnergySourceContainer>();
+    Ptr<energy::EnergySourceContainer> batteryContainer =
+        CreateObject<energy::EnergySourceContainer>();
     for (auto i = c.Begin(); i != c.End(); i++)
     {
         batteryContainer->Add(DoInstall(*i));
@@ -58,48 +59,50 @@
     return batteryContainer;
 }
 
-Ptr<EnergySource>
-GenericBatteryModelHelper::Install(Ptr<Node> node, BatteryModel bm) const
+Ptr<energy::EnergySource>
+GenericBatteryModelHelper::Install(Ptr<Node> node, energy::BatteryModel bm) const
 {
     NS_ASSERT(node != nullptr);
-    Ptr<EnergySource> energySource = m_batteryModel.Create<EnergySource>();
+    Ptr<energy::EnergySource> energySource = m_batteryModel.Create<energy::EnergySource>();
     NS_ASSERT(energySource != nullptr);
 
-    energySource->SetAttribute("FullVoltage", DoubleValue(g_batteryPreset[bm].vFull));
-    energySource->SetAttribute("MaxCapacity", DoubleValue(g_batteryPreset[bm].qMax));
+    energySource->SetAttribute("FullVoltage", DoubleValue(energy::g_batteryPreset[bm].vFull));
+    energySource->SetAttribute("MaxCapacity", DoubleValue(energy::g_batteryPreset[bm].qMax));
 
-    energySource->SetAttribute("NominalVoltage", DoubleValue(g_batteryPreset[bm].vNom));
-    energySource->SetAttribute("NominalCapacity", DoubleValue(g_batteryPreset[bm].qNom));
+    energySource->SetAttribute("NominalVoltage", DoubleValue(energy::g_batteryPreset[bm].vNom));
+    energySource->SetAttribute("NominalCapacity", DoubleValue(energy::g_batteryPreset[bm].qNom));
 
-    energySource->SetAttribute("ExponentialVoltage", DoubleValue(g_batteryPreset[bm].vExp));
-    energySource->SetAttribute("ExponentialCapacity", DoubleValue(g_batteryPreset[bm].qExp));
+    energySource->SetAttribute("ExponentialVoltage", DoubleValue(energy::g_batteryPreset[bm].vExp));
+    energySource->SetAttribute("ExponentialCapacity",
+                               DoubleValue(energy::g_batteryPreset[bm].qExp));
 
     energySource->SetAttribute("InternalResistance",
-                               DoubleValue(g_batteryPreset[bm].internalResistance));
+                               DoubleValue(energy::g_batteryPreset[bm].internalResistance));
     energySource->SetAttribute("TypicalDischargeCurrent",
-                               DoubleValue(g_batteryPreset[bm].typicalCurrent));
-    energySource->SetAttribute("CutoffVoltage", DoubleValue(g_batteryPreset[bm].cuttoffVoltage));
+                               DoubleValue(energy::g_batteryPreset[bm].typicalCurrent));
+    energySource->SetAttribute("CutoffVoltage",
+                               DoubleValue(energy::g_batteryPreset[bm].cuttoffVoltage));
 
-    energySource->SetAttribute("BatteryType", EnumValue(g_batteryPreset[bm].batteryType));
+    energySource->SetAttribute("BatteryType", EnumValue(energy::g_batteryPreset[bm].batteryType));
 
     energySource->SetNode(node);
     return energySource;
 }
 
-EnergySourceContainer
-GenericBatteryModelHelper::Install(NodeContainer c, BatteryModel bm) const
+energy::EnergySourceContainer
+GenericBatteryModelHelper::Install(NodeContainer c, energy::BatteryModel bm) const
 {
-    EnergySourceContainer batteryContainer;
+    energy::EnergySourceContainer batteryContainer;
     for (auto i = c.Begin(); i != c.End(); i++)
     {
-        Ptr<EnergySource> energySource = Install(*i, bm);
+        Ptr<energy::EnergySource> energySource = Install(*i, bm);
         batteryContainer.Add(energySource);
     }
     return batteryContainer;
 }
 
 void
-GenericBatteryModelHelper::SetCellPack(Ptr<EnergySource> energySource,
+GenericBatteryModelHelper::SetCellPack(Ptr<energy::EnergySource> energySource,
                                        uint8_t series,
                                        uint8_t parallel) const
 {
@@ -141,7 +144,7 @@
 }
 
 void
-GenericBatteryModelHelper::SetCellPack(EnergySourceContainer energySourceContainer,
+GenericBatteryModelHelper::SetCellPack(energy::EnergySourceContainer energySourceContainer,
                                        uint8_t series,
                                        uint8_t parallel) const
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/energy/helper/generic-battery-model-helper.h ns-3.42/src/energy/helper/generic-battery-model-helper.h
--- ns-3.41/src/energy/helper/generic-battery-model-helper.h	2024-02-09 14:44:07.905790000 -0800
+++ ns-3.42/src/energy/helper/generic-battery-model-helper.h	2024-05-29 15:29:46.948073100 -0700
@@ -55,7 +55,7 @@
      * \param c The node container
      * \returns An EnergySourceContainer which contains all the EnergySources.
      */
-    Ptr<EnergySourceContainer> Install(NodeContainer c) const;
+    Ptr<energy::EnergySourceContainer> Install(NodeContainer c) const;
 
     /**
      * This function installs an energy source (battery) into a node.
@@ -64,7 +64,7 @@
      * \param bm The battery model that will be install to the node.
      * \returns A pointer to the energy source object used.
      */
-    Ptr<EnergySource> Install(Ptr<Node> node, BatteryModel bm) const;
+    Ptr<energy::EnergySource> Install(Ptr<Node> node, energy::BatteryModel bm) const;
 
     /**
      * This function installs energy sources in a group of nodes in a
@@ -74,7 +74,7 @@
      * \param bm The battery model that will be install to the nodes in the node container.
      * \returns An EnergySourceContainer which contains all the EnergySources.
      */
-    EnergySourceContainer Install(NodeContainer c, BatteryModel bm) const;
+    energy::EnergySourceContainer Install(NodeContainer c, energy::BatteryModel bm) const;
 
     /**
      * This function takes an existing energy source and transform its values to form
@@ -86,7 +86,9 @@
      * \param series The number of cells connected in series.
      * \param parallel The number of cells connected in parallel.
      */
-    void SetCellPack(Ptr<EnergySource> energySource, uint8_t series, uint8_t parallel) const;
+    void SetCellPack(Ptr<energy::EnergySource> energySource,
+                     uint8_t series,
+                     uint8_t parallel) const;
 
     /**
      * This function takes an existing energy source container and transform the values
@@ -99,7 +101,7 @@
      * \param series The number of cells connected in series.
      * \param parallel The number of cells connected in parallel.
      */
-    void SetCellPack(EnergySourceContainer energySourceContainer,
+    void SetCellPack(energy::EnergySourceContainer energySourceContainer,
                      uint8_t series,
                      uint8_t parallel) const;
 
@@ -113,7 +115,7 @@
      * \param node Pointer to node where the energy source is to be installed.
      * \returns Pointer to the created EnergySource.
      */
-    Ptr<EnergySource> DoInstall(Ptr<Node> node) const override;
+    Ptr<energy::EnergySource> DoInstall(Ptr<Node> node) const override;
 
   private:
     ObjectFactory m_batteryModel; //!< The energy source (battery) used by this helper.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/energy/helper/li-ion-energy-source-helper.cc ns-3.42/src/energy/helper/li-ion-energy-source-helper.cc
--- ns-3.41/src/energy/helper/li-ion-energy-source-helper.cc	2024-02-09 14:44:07.905790000 -0800
+++ ns-3.42/src/energy/helper/li-ion-energy-source-helper.cc	2024-05-29 15:29:46.948073100 -0700
@@ -41,11 +41,11 @@
     m_liIonEnergySource.Set(name, v);
 }
 
-Ptr<EnergySource>
+Ptr<energy::EnergySource>
 LiIonEnergySourceHelper::DoInstall(Ptr<Node> node) const
 {
     NS_ASSERT(node);
-    Ptr<EnergySource> source = m_liIonEnergySource.Create<EnergySource>();
+    Ptr<energy::EnergySource> source = m_liIonEnergySource.Create<energy::EnergySource>();
     NS_ASSERT(source);
     source->SetNode(node);
     return source;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/energy/helper/li-ion-energy-source-helper.h ns-3.42/src/energy/helper/li-ion-energy-source-helper.h
--- ns-3.41/src/energy/helper/li-ion-energy-source-helper.h	2024-02-09 14:44:07.905790000 -0800
+++ ns-3.42/src/energy/helper/li-ion-energy-source-helper.h	2024-05-29 15:29:46.948073100 -0700
@@ -43,7 +43,7 @@
     void Set(std::string name, const AttributeValue& v) override;
 
   private:
-    Ptr<EnergySource> DoInstall(Ptr<Node> node) const override;
+    Ptr<energy::EnergySource> DoInstall(Ptr<Node> node) const override;
 
   private:
     ObjectFactory m_liIonEnergySource; //!< LiIon Battery factory
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/energy/helper/rv-battery-model-helper.cc ns-3.42/src/energy/helper/rv-battery-model-helper.cc
--- ns-3.41/src/energy/helper/rv-battery-model-helper.cc	2024-02-09 14:44:07.905790000 -0800
+++ ns-3.42/src/energy/helper/rv-battery-model-helper.cc	2024-05-29 15:29:46.948073100 -0700
@@ -39,11 +39,11 @@
     m_rvBatteryModel.Set(name, v);
 }
 
-Ptr<EnergySource>
+Ptr<energy::EnergySource>
 RvBatteryModelHelper::DoInstall(Ptr<Node> node) const
 {
     NS_ASSERT(node);
-    Ptr<EnergySource> source = m_rvBatteryModel.Create<EnergySource>();
+    Ptr<energy::EnergySource> source = m_rvBatteryModel.Create<energy::EnergySource>();
     NS_ASSERT(source);
     source->SetNode(node);
     return source;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/energy/helper/rv-battery-model-helper.h ns-3.42/src/energy/helper/rv-battery-model-helper.h
--- ns-3.41/src/energy/helper/rv-battery-model-helper.h	2024-02-09 14:44:07.905790000 -0800
+++ ns-3.42/src/energy/helper/rv-battery-model-helper.h	2024-05-29 15:29:46.948073100 -0700
@@ -41,7 +41,7 @@
     void Set(std::string name, const AttributeValue& v) override;
 
   private:
-    Ptr<EnergySource> DoInstall(Ptr<Node> node) const override;
+    Ptr<energy::EnergySource> DoInstall(Ptr<Node> node) const override;
 
   private:
     ObjectFactory m_rvBatteryModel; //!< RV Battery factory
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/energy/model/basic-energy-harvester.cc ns-3.42/src/energy/model/basic-energy-harvester.cc
--- ns-3.41/src/energy/model/basic-energy-harvester.cc	2024-02-09 14:44:07.905790000 -0800
+++ ns-3.42/src/energy/model/basic-energy-harvester.cc	2024-05-29 15:29:46.948073100 -0700
@@ -29,9 +29,10 @@
 
 namespace ns3
 {
+namespace energy
+{
 
 NS_LOG_COMPONENT_DEFINE("BasicEnergyHarvester");
-
 NS_OBJECT_ENSURE_REGISTERED(BasicEnergyHarvester);
 
 TypeId
@@ -183,4 +184,5 @@
     return m_harvestedPower;
 }
 
+} // namespace energy
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/energy/model/basic-energy-harvester.h ns-3.42/src/energy/model/basic-energy-harvester.h
--- ns-3.41/src/energy/model/basic-energy-harvester.h	2024-02-09 14:44:07.905790000 -0800
+++ ns-3.42/src/energy/model/basic-energy-harvester.h	2024-05-29 15:29:46.948073100 -0700
@@ -33,6 +33,8 @@
 
 namespace ns3
 {
+namespace energy
+{
 
 /**
  * \ingroup energy
@@ -128,6 +130,7 @@
     Time m_harvestedPowerUpdateInterval;   //!< harvestable energy update interval
 };
 
+} // namespace energy
 } // namespace ns3
 
 #endif /* defined(BASIC_ENERGY_HARVESTER) */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/energy/model/basic-energy-source.cc ns-3.42/src/energy/model/basic-energy-source.cc
--- ns-3.41/src/energy/model/basic-energy-source.cc	2024-02-09 14:44:07.905790000 -0800
+++ ns-3.42/src/energy/model/basic-energy-source.cc	2024-05-29 15:29:46.948073100 -0700
@@ -27,9 +27,10 @@
 
 namespace ns3
 {
+namespace energy
+{
 
 NS_LOG_COMPONENT_DEFINE("BasicEnergySource");
-
 NS_OBJECT_ENSURE_REGISTERED(BasicEnergySource);
 
 TypeId
@@ -231,4 +232,5 @@
     NS_LOG_DEBUG("BasicEnergySource:Remaining energy = " << m_remainingEnergyJ);
 }
 
+} // namespace energy
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/energy/model/basic-energy-source.h ns-3.42/src/energy/model/basic-energy-source.h
--- ns-3.41/src/energy/model/basic-energy-source.h	2024-02-09 14:44:07.905790000 -0800
+++ ns-3.42/src/energy/model/basic-energy-source.h	2024-05-29 15:29:46.948073100 -0700
@@ -28,6 +28,8 @@
 
 namespace ns3
 {
+namespace energy
+{
 
 /**
  * \ingroup energy
@@ -155,6 +157,7 @@
     Time m_energyUpdateInterval;            //!< energy update interval
 };
 
+} // namespace energy
 } // namespace ns3
 
 #endif /* BASIC_ENERGY_SOURCE_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/energy/model/device-energy-model.cc ns-3.42/src/energy/model/device-energy-model.cc
--- ns-3.41/src/energy/model/device-energy-model.cc	2024-02-09 14:44:07.905790000 -0800
+++ ns-3.42/src/energy/model/device-energy-model.cc	2024-05-29 15:29:46.948073100 -0700
@@ -23,9 +23,10 @@
 
 namespace ns3
 {
+namespace energy
+{
 
 NS_LOG_COMPONENT_DEFINE("DeviceEnergyModel");
-
 NS_OBJECT_ENSURE_REGISTERED(DeviceEnergyModel);
 
 TypeId
@@ -63,4 +64,5 @@
     return 0.0;
 }
 
+} // namespace energy
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/energy/model/device-energy-model-container.cc ns-3.42/src/energy/model/device-energy-model-container.cc
--- ns-3.41/src/energy/model/device-energy-model-container.cc	2024-02-09 14:44:07.905790000 -0800
+++ ns-3.42/src/energy/model/device-energy-model-container.cc	2024-05-29 15:29:46.948073100 -0700
@@ -26,6 +26,8 @@
 
 namespace ns3
 {
+namespace energy
+{
 
 NS_LOG_COMPONENT_DEFINE("DeviceEnergyModelContainer");
 
@@ -119,4 +121,5 @@
     m_models.clear();
 }
 
+} // namespace energy
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/energy/model/device-energy-model-container.h ns-3.42/src/energy/model/device-energy-model-container.h
--- ns-3.41/src/energy/model/device-energy-model-container.h	2024-02-09 14:44:07.905790000 -0800
+++ ns-3.42/src/energy/model/device-energy-model-container.h	2024-05-29 15:29:46.948073100 -0700
@@ -29,6 +29,8 @@
 
 namespace ns3
 {
+namespace energy
+{
 
 /**
  * \ingroup energy
@@ -173,6 +175,7 @@
     std::vector<Ptr<DeviceEnergyModel>> m_models; //!< Container of Energy models
 };
 
+} // namespace energy
 } // namespace ns3
 
 #endif /* DEVICE_ENERGY_MODEL_CONTAINER_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/energy/model/device-energy-model.h ns-3.42/src/energy/model/device-energy-model.h
--- ns-3.41/src/energy/model/device-energy-model.h	2024-02-09 14:44:07.905790000 -0800
+++ ns-3.42/src/energy/model/device-energy-model.h	2024-05-29 15:29:46.948073100 -0700
@@ -27,6 +27,8 @@
 
 namespace ns3
 {
+namespace energy
+{
 
 class EnergySource;
 
@@ -121,6 +123,7 @@
     virtual double DoGetCurrentA() const;
 };
 
+} // namespace energy
 } // namespace ns3
 
 #endif /* DEVICE_ENERGY_MODEL_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/energy/model/energy-harvester.cc ns-3.42/src/energy/model/energy-harvester.cc
--- ns-3.41/src/energy/model/energy-harvester.cc	2024-02-09 14:44:07.905790000 -0800
+++ ns-3.42/src/energy/model/energy-harvester.cc	2024-05-29 15:29:46.948073100 -0700
@@ -24,9 +24,10 @@
 
 namespace ns3
 {
+namespace energy
+{
 
 NS_LOG_COMPONENT_DEFINE("EnergyHarvester");
-
 NS_OBJECT_ENSURE_REGISTERED(EnergyHarvester);
 
 TypeId
@@ -100,4 +101,5 @@
     return 0.0;
 }
 
+} // namespace energy
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/energy/model/energy-harvester.h ns-3.42/src/energy/model/energy-harvester.h
--- ns-3.41/src/energy/model/energy-harvester.h	2024-02-09 14:44:07.905790000 -0800
+++ ns-3.42/src/energy/model/energy-harvester.h	2024-05-29 15:29:46.948073100 -0700
@@ -32,6 +32,8 @@
 
 namespace ns3
 {
+namespace energy
+{
 
 class EnergySource;
 
@@ -130,6 +132,7 @@
   protected:
 };
 
+} // namespace energy
 } // namespace ns3
 
 #endif /* defined(ENERGY_HARVESTER_H) */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/energy/model/energy-source.cc ns-3.42/src/energy/model/energy-source.cc
--- ns-3.41/src/energy/model/energy-source.cc	2024-02-09 14:44:07.905790000 -0800
+++ ns-3.42/src/energy/model/energy-source.cc	2024-05-29 15:29:46.948073100 -0700
@@ -28,9 +28,10 @@
 
 namespace ns3
 {
+namespace energy
+{
 
 NS_LOG_COMPONENT_DEFINE("EnergySource");
-
 NS_OBJECT_ENSURE_REGISTERED(EnergySource);
 
 TypeId
@@ -237,4 +238,5 @@
     m_node = nullptr;
 }
 
+} // namespace energy
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/energy/model/energy-source.h ns-3.42/src/energy/model/energy-source.h
--- ns-3.41/src/energy/model/energy-source.h	2024-02-09 14:44:07.905790000 -0800
+++ ns-3.42/src/energy/model/energy-source.h	2024-05-29 15:29:46.948073100 -0700
@@ -35,6 +35,10 @@
 
 namespace ns3
 {
+namespace energy
+{
+
+class EnergyHarvester;
 
 /**
  * \defgroup energy Energy Models
@@ -80,9 +84,6 @@
  * energy in different units (eg. kWh), a simple converter function should
  * suffice.
  */
-
-class EnergyHarvester;
-
 class EnergySource : public Object
 {
   public:
@@ -253,6 +254,7 @@
     void BreakDeviceEnergyModelRefCycle();
 };
 
+} // namespace energy
 } // namespace ns3
 
 #endif /* ENERGY_SOURCE_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/energy/model/generic-battery-model.cc ns-3.42/src/energy/model/generic-battery-model.cc
--- ns-3.41/src/energy/model/generic-battery-model.cc	2024-02-09 14:44:07.905790000 -0800
+++ ns-3.42/src/energy/model/generic-battery-model.cc	2024-05-29 15:29:46.948073100 -0700
@@ -32,9 +32,10 @@
 
 namespace ns3
 {
+namespace energy
+{
 
 NS_LOG_COMPONENT_DEFINE("GenericBatteryModel");
-
 NS_OBJECT_ENSURE_REGISTERED(GenericBatteryModel);
 
 TypeId
@@ -86,7 +87,7 @@
                           MakeDoubleAccessor(&GenericBatteryModel::m_internalResistance),
                           MakeDoubleChecker<double>())
             .AddAttribute("TypicalDischargeCurrent",
-                          "Typical discharge current used in manufacters datasheets (A)",
+                          "Typical discharge current used in manufacturers datasheets (A)",
                           DoubleValue(2.33),
                           MakeDoubleAccessor(&GenericBatteryModel::m_typicalCurrent),
                           MakeDoubleChecker<double>())
@@ -435,4 +436,5 @@
     return V;
 }
 
+} // namespace energy
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/energy/model/generic-battery-model.h ns-3.42/src/energy/model/generic-battery-model.h
--- ns-3.41/src/energy/model/generic-battery-model.h	2024-02-09 14:44:07.905790000 -0800
+++ ns-3.42/src/energy/model/generic-battery-model.h	2024-05-29 15:29:46.948073100 -0700
@@ -31,6 +31,8 @@
 
 namespace ns3
 {
+namespace energy
+{
 
 /**
  * \ingroup energy
@@ -309,6 +311,7 @@
     GenericBatteryType m_batteryType; //!< Indicates the battery type used by the model
 };
 
+} // namespace energy
 } // namespace ns3
 
 #endif /* GENERIC_BATTERY_MODEL_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/energy/model/li-ion-energy-source.cc ns-3.42/src/energy/model/li-ion-energy-source.cc
--- ns-3.41/src/energy/model/li-ion-energy-source.cc	2024-02-09 14:44:07.905790000 -0800
+++ ns-3.42/src/energy/model/li-ion-energy-source.cc	2024-05-29 15:29:46.948073100 -0700
@@ -29,9 +29,10 @@
 
 namespace ns3
 {
+namespace energy
+{
 
 NS_LOG_COMPONENT_DEFINE("LiIonEnergySource");
-
 NS_OBJECT_ENSURE_REGISTERED(LiIonEnergySource);
 
 TypeId
@@ -317,4 +318,5 @@
     return V;
 }
 
+} // namespace energy
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/energy/model/li-ion-energy-source.h ns-3.42/src/energy/model/li-ion-energy-source.h
--- ns-3.41/src/energy/model/li-ion-energy-source.h	2024-02-09 14:44:07.905790000 -0800
+++ ns-3.42/src/energy/model/li-ion-energy-source.h	2024-05-29 15:29:46.948073100 -0700
@@ -29,6 +29,8 @@
 
 namespace ns3
 {
+namespace energy
+{
 
 /**
  * \ingroup energy
@@ -215,6 +217,7 @@
     double m_minVoltTh;          //!< minimum threshold voltage to consider the battery depleted
 };
 
+} // namespace energy
 } // namespace ns3
 
 #endif /* LI_ION_ENERGY_SOURCE_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/energy/model/rv-battery-model.cc ns-3.42/src/energy/model/rv-battery-model.cc
--- ns-3.41/src/energy/model/rv-battery-model.cc	2024-02-09 14:44:07.905790000 -0800
+++ ns-3.42/src/energy/model/rv-battery-model.cc	2024-05-29 15:29:46.948073100 -0700
@@ -29,9 +29,10 @@
 
 namespace ns3
 {
+namespace energy
+{
 
 NS_LOG_COMPONENT_DEFINE("RvBatteryModel");
-
 NS_OBJECT_ENSURE_REGISTERED(RvBatteryModel);
 
 TypeId
@@ -379,4 +380,5 @@
     return delta + 2 * sum;
 }
 
+} // namespace energy
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/energy/model/rv-battery-model.h ns-3.42/src/energy/model/rv-battery-model.h
--- ns-3.41/src/energy/model/rv-battery-model.h	2024-02-09 14:44:07.905790000 -0800
+++ ns-3.42/src/energy/model/rv-battery-model.h	2024-05-29 15:29:46.948073100 -0700
@@ -28,6 +28,8 @@
 
 namespace ns3
 {
+namespace energy
+{
 
 /**
  * \ingroup energy
@@ -263,6 +265,7 @@
     TracedValue<Time> m_lifetime; //!< time of death of the battery
 };
 
+} // namespace energy
 } // namespace ns3
 
 #endif /* RV_BATTERY_MODEL_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/energy/model/simple-device-energy-model.cc ns-3.42/src/energy/model/simple-device-energy-model.cc
--- ns-3.41/src/energy/model/simple-device-energy-model.cc	2024-02-09 14:44:07.905790000 -0800
+++ ns-3.42/src/energy/model/simple-device-energy-model.cc	2024-05-29 15:29:46.948073100 -0700
@@ -27,9 +27,10 @@
 
 namespace ns3
 {
+namespace energy
+{
 
 NS_LOG_COMPONENT_DEFINE("SimpleDeviceEnergyModel");
-
 NS_OBJECT_ENSURE_REGISTERED(SimpleDeviceEnergyModel);
 
 TypeId
@@ -132,4 +133,5 @@
     return m_actualCurrentA;
 }
 
+} // namespace energy
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/energy/model/simple-device-energy-model.h ns-3.42/src/energy/model/simple-device-energy-model.h
--- ns-3.41/src/energy/model/simple-device-energy-model.h	2024-02-09 14:44:07.905790000 -0800
+++ ns-3.42/src/energy/model/simple-device-energy-model.h	2024-05-29 15:29:46.948073100 -0700
@@ -27,6 +27,8 @@
 
 namespace ns3
 {
+namespace energy
+{
 
 /**
  * \ingroup energy
@@ -141,6 +143,7 @@
     TracedValue<double> m_totalEnergyConsumption; //!< Total energy consumption trace
 };
 
+} // namespace energy
 } // namespace ns3
 
 #endif /* SIMPLE_DEVICE_ENERGY_MODEL_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/energy/test/basic-energy-harvester-test.cc ns-3.42/src/energy/test/basic-energy-harvester-test.cc
--- ns-3.41/src/energy/test/basic-energy-harvester-test.cc	2024-02-09 14:44:07.909790000 -0800
+++ ns-3.42/src/energy/test/basic-energy-harvester-test.cc	2024-05-29 15:29:46.948073100 -0700
@@ -29,6 +29,7 @@
 #include "ns3/test.h"
 
 using namespace ns3;
+using namespace ns3::energy;
 
 NS_LOG_COMPONENT_DEFINE("BasicEnergyHarvesterTestSuite");
 
@@ -133,9 +134,9 @@
 };
 
 BasicEnergyHarvesterTestSuite::BasicEnergyHarvesterTestSuite()
-    : TestSuite("basic-energy-harvester", UNIT)
+    : TestSuite("basic-energy-harvester", Type::UNIT)
 {
-    AddTestCase(new BasicEnergyHarvesterTestCase, TestCase::QUICK);
+    AddTestCase(new BasicEnergyHarvesterTestCase, TestCase::Duration::QUICK);
 }
 
 /// create an instance of the test suite
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/energy/test/examples-to-run.py ns-3.42/src/energy/test/examples-to-run.py
--- ns-3.41/src/energy/test/examples-to-run.py	2024-02-09 14:44:07.909790000 -0800
+++ ns-3.42/src/energy/test/examples-to-run.py	2024-05-29 15:29:46.948073100 -0700
@@ -18,4 +18,6 @@
 #     (example_name, do_run).
 #
 # See test.py for more information.
-python_examples = []
+python_examples = [
+    ("generic-battery-discharge-example.py", "True"),
+]
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/energy/test/li-ion-energy-source-test.cc ns-3.42/src/energy/test/li-ion-energy-source-test.cc
--- ns-3.41/src/energy/test/li-ion-energy-source-test.cc	2024-02-09 14:44:07.909790000 -0800
+++ ns-3.42/src/energy/test/li-ion-energy-source-test.cc	2024-05-29 15:29:46.948073100 -0700
@@ -25,6 +25,7 @@
 #include "ns3/test.h"
 
 using namespace ns3;
+using namespace ns3::energy;
 
 NS_LOG_COMPONENT_DEFINE("LiIonEnergySourceTestSuite");
 
@@ -92,9 +93,9 @@
 };
 
 LiIonEnergySourceTestSuite::LiIonEnergySourceTestSuite()
-    : TestSuite("li-ion-energy-source", UNIT)
+    : TestSuite("li-ion-energy-source", Type::UNIT)
 {
-    AddTestCase(new LiIonEnergyTestCase, TestCase::QUICK);
+    AddTestCase(new LiIonEnergyTestCase, TestCase::Duration::QUICK);
 }
 
 /// create an instance of the test suite
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/fd-net-device/helper/creator-utils.cc ns-3.42/src/fd-net-device/helper/creator-utils.cc
--- ns-3.41/src/fd-net-device/helper/creator-utils.cc	2024-02-09 14:44:07.909790000 -0800
+++ ns-3.42/src/fd-net-device/helper/creator-utils.cc	2024-05-29 15:29:46.948073100 -0700
@@ -113,7 +113,7 @@
     // an "ancillary element" but the msghdr uses the control message termimology
     // so we call it "control."
     //
-    size_t msg_size = sizeof(int);
+    constexpr size_t msg_size = sizeof(int);
     char control[CMSG_SPACE(msg_size)];
 
     //
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/fd-net-device/helper/dpdk-net-device-helper.h ns-3.42/src/fd-net-device/helper/dpdk-net-device-helper.h
--- ns-3.41/src/fd-net-device/helper/dpdk-net-device-helper.h	2024-02-09 14:44:07.909790000 -0800
+++ ns-3.42/src/fd-net-device/helper/dpdk-net-device-helper.h	2024-05-29 15:29:46.948073100 -0700
@@ -27,10 +27,9 @@
 {
 
 /**
- * \ingroup dpdk-net-device
+ * \ingroup fd-net-device
  * \brief build a DpdkNetDevice object attached to a physical network
  * interface
- *
  */
 class DpdkNetDeviceHelper : public EmuFdNetDeviceHelper
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/fd-net-device/helper/emu-fd-net-device-helper.cc ns-3.42/src/fd-net-device/helper/emu-fd-net-device-helper.cc
--- ns-3.41/src/fd-net-device/helper/emu-fd-net-device-helper.cc	2024-02-09 14:44:07.909790000 -0800
+++ ns-3.42/src/fd-net-device/helper/emu-fd-net-device-helper.cc	2024-05-29 15:29:46.948073100 -0700
@@ -380,7 +380,7 @@
         // an "ancillary element" but the msghdr uses the control message terminology
         // so we call it "control."
         //
-        size_t msg_size = sizeof(int);
+        constexpr size_t msg_size = sizeof(int);
         char control[CMSG_SPACE(msg_size)];
 
         //
